{{
''********************************************
''*  ezLCD-301 application note from bs2     *
''*  Author:                                 *
''*  Translated to SPIN by Joe Heinz         *
''*  Copyright (c) 2012 EarthLCD.com         *
''*  See end of file for terms of use.       *
''********************************************
}}
{-----------------REVISION HISTORY-----------------
 v1.0 - x/x/2012 first official release.
}
     ezLCDtx     = 1                                         'The ezLCD tx pin (RX pin on prop)                                 , change as needed
     ezLCDrx     = 0                                         'The ezLCD rx pin (TX pin on prop)                                 , change as needed
     ezLCDbaud   = 9600                                      'the ezLCD baud-rate                                               , change as needed
     pinOut      = 22                                        'This is the pin to toggle on and off                              , change as needed
     pstBaud     = 115200                                    'This is the baud-rate for Parallax Serial Terminal Debugger       , change as needed
     
VAR
 byte serStr[6], idx, c                                                        'define a 6-byte string array for storing the data received from ezLCD  

OBJ serial : "FullDuplexSerial"                                                'This object does the actual serial communication with the display   *Thanks Chip Gracey, Jeff Martin
    wait   : "timing"                                                          'This object is for simple timing                                    *Thanks Parallax
    pst    : "parallax serial terminal"                                        'This object is for debugging to PC, comment out if not used         *Thanks Jeff Martin, Andy Lindsay, Chip Gracey
    
PUB BOOT                                                                       ''This method runs at startup
serial.start(ezLCDrx,ezLCDtx, 0, ezLCDbaud)                                    'Start fullDuplex serial driver with ezLCD pins @ ezLCDbaud, mode 0. Returns false if no cog available.
pst.start(pstBaud)                                                             'Start Parallax Serial Terminal @ pstBaud, comment out if used
dira[pinOut] ++                                                                'Make pinOut an output

serial.str(string("cls black"))                                                'Clears the display to black
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("theme 1 9 3 0 0 0 8 8 8 8"))                                'Defines Theme 1 for button 1
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("theme 2 5 20 3 3 3 4 4 4 4"))                               'Defines Theme 2 for button 2
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("fontw 1 sans72"))                                           'define font for button 1 widget
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("fontw 2 sans72"))                                           'defines font for button widget 2
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("string 1 ON"))                                              'defines string for button 1
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("string 2 OFF"))                                             'defines string for button2
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("button 1 10 40 185 140 1 0 25 1 1"))                        'defines button 1                   
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1ms(10)                                                              'Wait 10ms

serial.str(string("button 2 205 40 185 140 1 0 25 2 2"))                       'defines button 2
CR_LF                                                                          'Send Carriage Return + Line Feed

wait.pause1s(3)                                                                'Wait 3 Seconds for ezLCD to finish sending feedback about it's displays

serial.rxflush                                                                 'Clear serial receive buffer
pst.clear                                                                      'Clear parallax Serial Terminal, comment out if not used

'   Main Loop starts here
repeat                                                                         'Repeat loop starts here
  idx ~                                                                        'Clear idx
  repeat while (c:= serial.rx) <> 13                                           'Copy serial receive buffer into c and repeat until Carriage Return is received,  CR signifies end of string from display 
      serStr[idx++] := c                                                       'Move receive buffer into serStr then increment idx, 
  serStr[idx] ~                                                                'Set last byte to 0, for 0 terminated string to Parallax Serial Terminal
  pst.str(@serStr)                                                             'Send serStr to Parallax serial Terminal, comment out if not used
  pst.newline                                                                  'Send newline to Parallax Serial Terminal, comment out if not used
  if serStr[0] == "B" and serStr[1] == "P" and serStr[2] == "1"                'If received data is BP1 which means button 1 pressed
    outa[pinOut] := 1                                                            'then set pinOut high 
  if serStr[0] == "B" and serStr[1] == "P" and serStr[2] == "2"                'If received data is BP2 which means button 2 pressed 
    outa[pinOut] ~                                                               'then set pinOut low
serial.rxflush                                                                 'clear serial receive buffer for next iteration
bytefill(@serStr,6,0)                                                          'clear serString for next iteration

PUB CR_LF                                                                      ''Send Carriage Return + Line Feed
serial.tx(13)                                                                  ' Send Carriage Return to display
serial.tx(10)                                                                  ' Send Line Feed to display